package eu.headcrashing;

import java.time.Instant;
import java.util.List;
import java.util.stream.Collectors;

import javax.ws.rs.GET;
import javax.ws.rs.MatrixParam;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

import eu.headcrashing.NotebookApplication.Note;

@Path("notebook")
public class BadNotebookResource {
	// Cannot replace for testing :-(
	NotebookApplication notebookApplication = new NotebookApplication();

	// Strings are pretty simple and straightforward to handle! :-)
	@GET
	@Produces("text/plain")
	public List<String> getNotesAsStringList(@MatrixParam("from") final String startDate, @MatrixParam("to") final String endDate) {
		final List<Note> notes = this.notesAsList(startDate, endDate);
		final List<String> notesAsStrings = notes.stream().map(Note::toString).collect(Collectors.toList());
		// TODO Implement Note::toString!
		return notesAsStrings;
	}

	private List<Note> notesAsList(final String startDate, final String endDate) {
		return this.notebookApplication.getNotes(new TimeSpan(Instant.parse(startDate), Instant.parse(endDate))).asList();
	}

	// Hopefully JAXB support will not get deprecated sometimes... ;-)
	@GET
	@Produces("application/xml")
	public List<Note> getNotesAsXML(@MatrixParam("from") final String startDate, @MatrixParam("to") final String endDate) {
		final List<Note> notes = this.notesAsList(startDate, endDate);
		// TODO Add @XmlRootElement to Note class
		return notes;
	}

	// Now we're rather screwed! :-(
	@GET
	@Produces("application/pdf")
	public PDF /* TBD */getNotesAsPDF(@MatrixParam("from") final String startDate, @MatrixParam("to") final String endDate) {
		final List<Note> notes = this.notesAsList(startDate, endDate);
		final PDF pdf = useFOP(notes); // TODO fix this!
		return pdf;
	}
}